VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cad"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


Dim ultimoandar As Integer
Dim uniao As Acad3DSolid
Dim flag As Boolean
'Altura de cada andar
Dim altura As Double
'Layer actual
Dim layeractual As String
'aplicao autcad

Dim acad As AutoCAD.AcadApplication
'desenho actual do autocad
Dim Thisdrawing As Object
'modelspace
Dim modelspace As AutoCAD.AcadModelSpace


Private Sub Class_Initialize()
    Set acad = New AutoCAD.AcadApplication
    altura = 10
    flag = False
    Set Thisdrawing = acad.ActiveDocument
    
    Set modelspace = Thisdrawing.modelspace
    
    

    Call run_comando("-view _swiso")
    
End Sub

Public Sub ver_autocad(visivel As Boolean)

If visivel = True Then
    acad.Visible = True
Else
    acad.Visible = False
End If

End Sub


Public Sub run_comando(comando As String)

    Thisdrawing.SendCommand (comando + Chr(13))
 

End Sub



Private Sub criar_layer(nome As String, cor As Variant)


Dim layerObj As AcadLayer
Set layerObj = Thisdrawing.layers.Add(nome)


'as cores pode ser do tipo acBlue, acRed, etc.
layerObj.color = cor


End Sub


Public Sub layers()

Call criar_layer("grelha", acBlue)
layeractual = "rc"

Call criar_layer("NODOS", acRed)

End Sub



Public Sub grelha_nodos(altura_andar As Double)

Dim i As Integer
Dim j As Integer
        Dim ponto_inicio(0 To 2) As Double
        Dim ponto_fim(0 To 2) As Double
        Dim linha As AutoCAD.AcadLine
        
        
        For i = 0 To TAM_X / LADO_QUADRICULA
                ponto_inicio(0) = ESCALA * i
                ponto_inicio(1) = 0
                ponto_inicio(2) = altura_andar
                
        
                ponto_fim(0) = ESCALA * i
                ponto_fim(1) = -(TAM_Y / LADO_QUADRICULA) * ESCALA
                ponto_fim(2) = altura_andar
                   
                   Set linha = modelspace.AddLine(ponto_inicio, ponto_fim)
                    linha.Layer = "grelha"
                    linha.Update
        Next
        DoEvents
        
        For i = 0 To TAM_Y / LADO_QUADRICULA
                ponto_inicio(0) = 0
                ponto_inicio(1) = -ESCALA * i
                ponto_inicio(2) = altura_andar
        
                ponto_fim(0) = (TAM_X / LADO_QUADRICULA) * ESCALA
                ponto_fim(1) = -ESCALA * i
                ponto_fim(2) = altura_andar
                
                    Set linha = modelspace.AddLine(ponto_inicio, ponto_fim)
                    linha.Layer = "grelha"
                    linha.Update
                    
        Next
  
        
        Dim node As AcadEntity
        Dim posicao(0 To 2) As Double


        For i = 0 To (TAM_X / LADO_QUADRICULA) - 1
            For j = 0 To (TAM_Y / LADO_QUADRICULA) - 1

                posicao(0) = ESCALA * i + ESCALA / 2
                posicao(1) = -ESCALA * j + ESCALA / 2
                posicao(2) = altura_andar


                Set node = modelspace.AddPoint(posicao)
                node.Layer = "NODOS"
                node.Update

                DoEvents

            Next
        Next

        

End Sub

Public Sub load_macro()
acad.LoadDVB (App.Path + "\Mobiliario.dvb")
End Sub
Public Sub run_macro()


'acad.LoadDVB (App.Path + "\Mobiliario.dvb")
acad.RunMacro (App.Path + "\Mobiliario.dvb!Module1.start")

End Sub




Public Sub desenha_Moradia()

    Dim alturatecto As Double
    If (Principal.l_1 <> "Nenhum") Then
        ultimoandar = 0
    
    ElseIf (Principal.l_2 <> "Nenhum") Then
        ultimoandar = 1
    Else
        ultimoandar = 2
    End If
            
    
    If (Principal.l_rc = "Nenhum") Then
        MsgBox ("Tem que existir um andar de R/Cho criado")
         
        Exit Sub
    Else
       grelha_nodos (0)
       Call criar_layer("rc", acWhite)
       layeractual = "rc"
       Call desenhaAndar(0, Principal.l_rc, 0)
        
    End If
    
    If (Principal.l_1 <> "Nenhum") Then
        grelha_nodos (CDbl(altura * ESCALA + ESCALA))
        Call criar_layer("andar1", acWhite)
        layeractual = "andar1"
        Call desenhaAndar(1, Principal.l_1, altura * ESCALA + ESCALA)

        
        If (Principal.l_2 <> "Nenhum") Then
            grelha_nodos (CDbl(altura * 2 * ESCALA + ESCALA * 2))
            Call criar_layer("andar2", acWhite)
             layeractual = "andar2"
             Call desenhaAndar(2, Principal.l_2, altura * 2 * ESCALA + ESCALA * 2)
         
        End If
            
    End If
    
   
    
  
End Sub
Private Sub desenhaTelhado(alturatelhado As Double)

    
End Sub

Public Sub desenhaAndar(andaractual As Integer, filename As String, AltAndar As Double)

         Dim lixo
        Dim temp As String
        Dim i As Integer
        Dim j As Integer
        Dim x As Double
        Dim y As Double
        Dim h As Double
        Dim v As Double
        Dim color As Long
        Dim editavel As Boolean
        Dim num_elementos As Long
        Dim NUMX As Integer
        Dim NUMY As Integer
        
        flag = False
        Set uniao = Nothing
        
        NUMX = CInt(TAM_X / LADO_QUADRICULA)
        NUMY = CInt(TAM_Y / LADO_QUADRICULA)
       
        
        Dim Maxx() As Double
        Dim Minx() As Double
        
        ReDim Preserve Maxx(NUMY)
        ReDim Preserve Minx(NUMY)
        
        Dim tempxmax As Double
        Dim tempxmin As Double
        
        Dim VX As Integer
        Dim VY As Integer
        
       
        
        '0 Significa que em para esta coluna em Y no h paredes
        For i = 1 To NUMY
            Maxx(i) = 0
            Minx(i) = 0
        Next
        
        
        
        Open filename For Input As #1

        Input #1, lixo
        Input #1, temp
        
        num_elementos = CLng(temp)
         
        For i = 1 To num_elementos
            
            Input #1, temp
            x = CLng(temp)
            Input #1, temp
            y = CLng(temp)
            Input #1, temp
            h = CLng(temp)
            Input #1, temp
            v = CLng(temp)
            Input #1, temp
            color = CLng(temp)
            Input #1, temp
            editavel = CStr(temp)
            
            Call desenha(color, x, y, h + 1, v + 1, AltAndar)
            
            'Vx e vy correspondem  indexao das colunas
            VX = Int(x / LADO_QUADRICULA)
            VY = Int(y / LADO_QUADRICULA)
            
            
            tempxmax = x / LADO_QUADRICULA * ESCALA + ESCALA * h
            tempxmin = x / LADO_QUADRICULA * ESCALA
        
            'tempymax = -(VY + ESCALA * (y - 1))
            'tempymin = -VY
            
            'Clculos para calcular limites da casa
            For j = VY To VY + v
                 If tempxmin < Minx(j) Or Minx(j) = 0 Then
                      Minx(j) = tempxmin
                 End If
                    
                If tempxmax > Maxx(j) Or Maxx(j) = 0 Then
                     Maxx(j) = tempxmax
                End If
            Next
        
        Next
        
        
       Call desenha_tecto(AltAndar, Maxx, Minx)
       
       Close #1
       
       Dim col As AcadAcCmColor
       Set col = acad.GetInterfaceObject("AutoCAD.AcCmColor.16")
       
        If Principal.l_parede = "Tipo 1" Then
            Call col.SetRGB(255, 255, 255)
            
        End If
        If Principal.l_parede = "Tipo 2" Then
            Call col.SetRGB(105, 72, 22)
           
        End If
                If Principal.l_parede = "Tipo 3" Then
            Call col.SetRGB(255, 128, 0)
            
        End If
        uniao.TrueColor = col
        
        If andaractual = ultimoandar Then
           Call desenhaTelhado(AltAndar)
        End If
End Sub

 

Private Sub desenha_tecto(AltAndar As Double, Maxx() As Double, Minx() As Double)
    Dim NUMX As Integer
    Dim NUMY As Integer
    Dim i As Integer
    Dim pt(0 To 2) As Double
    Dim TECTO As Acad3DSolid
    Dim Cumprimento As Double
    
    
    NUMX = Int(TAM_X / LADO_QUADRICULA)
    NUMY = Int(TAM_Y / LADO_QUADRICULA)
    
    For i = 1 To NUMY
        If Minx(i) <> 0 And Maxx(i) <> 0 Then
        
            If Maxx(i) = Minx(i) Then
                Cumprimento = ESCALA
            Else
                Cumprimento = Maxx(i) - Minx(i) + ESCALA
            End If
            
            pt(0) = Minx(i) + (Maxx(i) - Minx(i)) / 2
            pt(1) = -i * ESCALA - ESCALA / 2
            pt(2) = altura * ESCALA + AltAndar + ESCALA / 2
                 
            Set TECTO = modelspace.AddBox(pt, Cumprimento, ESCALA, ESCALA)
            TECTO.Layer = layeractual
        
            If flag = False Then
              Set uniao = TECTO
              flag = True
            Else
                uniao.Boolean acUnion, TECTO
            End If
         End If
     Next
 
End Sub

Public Sub desenha(TipoCor As Long, x As Double, y As Double, h As Double, v As Double, z As Double)
    
   Dim pt(0 To 2) As Double
   Dim ch As Double
   Dim cv As Double
   Dim tempx As Long
   Dim tempy As Long
 
   pt(0) = x / LADO_QUADRICULA * ESCALA
   pt(1) = y / LADO_QUADRICULA * ESCALA
   pt(2) = z
    ch = h
    cv = v
    
    Select Case TipoCor
    
        Case COR_PAREDE And h > 1:
            Call desenha_parede_horizontal(pt, ch)
            
        Case COR_PAREDE And v > 1:
            Call desenha_parede_vertical(pt, cv)
            
        Case COR_PAREDE And h = 1 And v = 1:
             Call desenha_Parede(pt)
            
        Case COR_JANELAH:
            Call desenha_janela_horizontal(pt)
            
        Case COR_JANELAV:
            Call desenha_janela_vertical(pt)
        Case COR_PORTAH
            Call desenha_porta_horizontal(pt)
         Case COR_PORTAV
            Call desenha_porta_vertical(pt)
        
    End Select


End Sub
Private Sub desenha_porta_horizontal(pt)
    Dim pttemp(0 To 2) As Double
    Dim Parede1 As Acad3DSolid
    Dim Parede2 As Acad3DSolid
    Dim Parede3 As Acad3DSolid
    Dim Parede4 As Acad3DSolid
    
    pttemp(0) = pt(0) - ESCALA / 4
    pttemp(1) = -pt(1)
    pttemp(2) = pt(2) + altura * ESCALA / 2
       
    Set Parede1 = modelspace.AddBox(pttemp, ESCALA / 2, ESCALA, altura * ESCALA)
    Parede1.Layer = layeractual
    
    pttemp(0) = pt(0) + ESCALA * 3 + ESCALA / 4
    Set Parede2 = modelspace.AddBox(pttemp, ESCALA / 2, ESCALA, altura * ESCALA)
    Parede2.Layer = layeractual
        
    pttemp(0) = pt(0) + ESCALA * 3 / 2
    pttemp(2) = pt(2) + altura * ESCALA - altura * ESCALA / 8
    Set Parede3 = modelspace.AddBox(pttemp, 3 * ESCALA, ESCALA, altura * ESCALA / 4)
    Parede3.Layer = layeractual
    
     If flag = False Then
              Set uniao = Parede1
              flag = True
    Else
               uniao.Boolean acUnion, Parede1
              
    End If

     uniao.Boolean acUnion, Parede2
    uniao.Boolean acUnion, Parede3
End Sub
Public Sub desenha_porta_vertical(pt)
 Dim pttemp(0 To 2) As Double
    Dim Parede1 As Acad3DSolid
    Dim Parede2 As Acad3DSolid
    Dim Parede3 As Acad3DSolid
    Dim Parede4 As Acad3DSolid
    
    pttemp(0) = pt(0)
    pttemp(1) = -pt(1) + ESCALA / 4
    pttemp(2) = pt(2) + altura * ESCALA / 2
       
    Set Parede1 = modelspace.AddBox(pttemp, ESCALA, ESCALA / 2, altura * ESCALA)
    Parede1.Layer = layeractual
    
    pttemp(1) = -pt(1) - ESCALA * 3 - ESCALA / 4
    Set Parede2 = modelspace.AddBox(pttemp, ESCALA, ESCALA / 2, altura * ESCALA)
    Parede2.Layer = layeractual
    
    pttemp(1) = -pt(1) - ESCALA * 3 / 2
    pttemp(2) = pt(2) + altura * ESCALA - altura * ESCALA / 8
    Set Parede3 = modelspace.AddBox(pttemp, ESCALA, 3 * ESCALA, altura * ESCALA / 4)
    Parede3.Layer = layeractual
    
     If flag = False Then
              Set uniao = Parede1
              flag = True
    Else
               uniao.Boolean acUnion, Parede1
              
    End If

     uniao.Boolean acUnion, Parede2
    uniao.Boolean acUnion, Parede3
 
End Sub

Private Sub desenha_janela_horizontal(pt() As Double)
    Dim pttemp(0 To 2) As Double
    Dim Parede1 As Acad3DSolid
    Dim Parede2 As Acad3DSolid
    Dim Parede3 As Acad3DSolid
    Dim Parede4 As Acad3DSolid
    
    pttemp(0) = pt(0) - ESCALA / 4
    pttemp(1) = -pt(1)
    pttemp(2) = pt(2) + altura * ESCALA / 2
       
    Set Parede1 = modelspace.AddBox(pttemp, ESCALA / 2, ESCALA, altura * ESCALA)
    Parede1.Layer = layeractual
    
    pttemp(0) = pt(0) + ESCALA * 3 + ESCALA / 4
    Set Parede2 = modelspace.AddBox(pttemp, ESCALA / 2, ESCALA, altura * ESCALA)
    Parede2.Layer = layeractual
    
   
        
    pttemp(0) = pt(0) + ESCALA * 3 / 2
    pttemp(2) = pt(2) + altura * ESCALA - altura * ESCALA / 8
    Set Parede3 = modelspace.AddBox(pttemp, 3 * ESCALA, ESCALA, altura * ESCALA / 4)
    Parede3.Layer = layeractual

     pttemp(2) = pt(2) + altura * ESCALA / 8
     Set Parede4 = modelspace.AddBox(pttemp, 3 * ESCALA, ESCALA, altura * ESCALA / 4)
     Parede4.Layer = layeractual
     
      If flag = False Then
              Set uniao = Parede1
              flag = True
    Else
               uniao.Boolean acUnion, Parede1
              
    End If

     uniao.Boolean acUnion, Parede2
    uniao.Boolean acUnion, Parede3
    uniao.Boolean acUnion, Parede4
End Sub
Private Sub desenha_janela_vertical(pt() As Double)
    Dim pttemp(0 To 2) As Double
    Dim Parede1 As Acad3DSolid
    Dim Parede2 As Acad3DSolid
    Dim Parede3 As Acad3DSolid
    Dim Parede4 As Acad3DSolid
    
    pttemp(0) = pt(0)
    pttemp(1) = -pt(1) + ESCALA / 4
    pttemp(2) = pt(2) + altura * ESCALA / 2
       
    Set Parede1 = modelspace.AddBox(pttemp, ESCALA, ESCALA / 2, altura * ESCALA)
    Parede1.Layer = layeractual
    
    pttemp(1) = -pt(1) - ESCALA * 3 - ESCALA / 4
    Set Parede2 = modelspace.AddBox(pttemp, ESCALA, ESCALA / 2, altura * ESCALA)
    Parede2.Layer = layeractual
    
   
        
    pttemp(1) = -pt(1) - ESCALA * 3 / 2
    pttemp(2) = pt(2) + altura * ESCALA - altura * ESCALA / 8
    Set Parede3 = modelspace.AddBox(pttemp, ESCALA, 3 * ESCALA, altura * ESCALA / 4)
    Parede3.Layer = layeractual

     pttemp(2) = pt(2) + altura * ESCALA / 8
     Set Parede4 = modelspace.AddBox(pttemp, ESCALA, 3 * ESCALA, altura * ESCALA / 4)
     Parede4.Layer = layeractual
     
     If flag = False Then
              Set uniao = Parede1
              flag = True
    Else
               uniao.Boolean acUnion, Parede1
              
    End If

     uniao.Boolean acUnion, Parede2
    uniao.Boolean acUnion, Parede3
    uniao.Boolean acUnion, Parede4
     
     

End Sub

Private Sub desenha_Parede(pt() As Double)
    Dim Parede As Acad3DSolid
    
    pt(0) = pt(0)
    pt(1) = -pt(1)
    pt(2) = pt(2) + altura * ESCALA / 2
    
    Set Parede = modelspace.AddBox(pt, ESCALA, ESCALA, altura * ESCALA)
    Parede.Layer = layeractual
    
    If flag = False Then
              Set uniao = Parede
              flag = True
    Else
               uniao.Boolean acUnion, Parede
              
    End If
 
End Sub
Private Sub desenha_parede_horizontal(pt() As Double, Comp As Double)
    Dim Parede As Acad3DSolid
    
    pt(0) = pt(0) + ESCALA * (Comp - 1) / 2
    pt(1) = -pt(1)
    pt(2) = pt(2) + altura * ESCALA / 2
    
    Set Parede = modelspace.AddBox(pt, Comp * ESCALA, ESCALA, altura * ESCALA)
     Parede.Layer = layeractual
     
        If flag = False Then
              Set uniao = Parede
              flag = True
    Else
               uniao.Boolean acUnion, Parede
              
    End If
 
    
End Sub

 Private Sub desenha_parede_vertical(pt() As Double, Comp As Double)
  
     Dim Parede As Acad3DSolid
    
    pt(0) = pt(0)
    pt(1) = -pt(1) - ESCALA * (Comp - 1) / 2
    pt(2) = pt(2) + altura * ESCALA / 2
    
    Set Parede = modelspace.AddBox(pt, ESCALA, Comp * ESCALA, altura * ESCALA)
     Parede.Layer = layeractual
     
        If flag = False Then
              Set uniao = Parede
              flag = True
    Else
               uniao.Boolean acUnion, Parede
              
    End If
 
End Sub
Public Sub atribuiAltura(A As Long)
    altura = A
End Sub
 

